"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
class Lock {
    constructor() {
        this._locked = false;
        this.toCome = [];
        this.release = this.release.bind(this);
    }
    get locked() {
        return this._locked;
    }
    getLock() {
        return __awaiter(this, void 0, void 0, function* () {
            if (!this._locked)
                return { release: this.lock() };
            else {
                return new Promise((resolve) => {
                    this.toCome.push(() => {
                        resolve({ release: this.lock() });
                    });
                });
            }
        });
    }
    lock() {
        this._locked = true;
        return this.release;
    }
    release() {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.toCome.length > 0) {
                this.toCome.shift()();
            }
            else {
                this._locked = false;
            }
        });
    }
}
exports.default = Lock;
//# sourceMappingURL=lock.js.map